#pragma once

#include <SDL2/SDL.h>
#include <cstdint>
#include <string>
#include "utils.h"

using namespace Util;

namespace Mandelbrot {

    class Graphics {
    public:
        std::string title;
        int w, h;
        SDL_Window *window;
        SDL_Renderer *renderer;

        Graphics(int w, int h, std::string title);
        void plot(const Vec2bf &from, const Vec2bf &to);
        void drawPoint(const Vec2i &pos, const rgb &col);
    };
} // namespace Mandelbrot
